diff --git a/lib/app/data/providers/auth_provider.dart b/lib/app/data/providers/auth_provider.dart
index 921ca54..39fae41 100644
--- a/lib/app/data/providers/auth_provider.dart
+++ b/lib/app/data/providers/auth_provider.dart
@@ -1,44 +1,162 @@
 import 'package:penyaluran_app/app/services/supabase_service.dart';
 import 'package:penyaluran_app/app/data/models/user_model.dart';
+import 'package:penyaluran_app/app/data/models/warga_model.dart';
+import 'package:penyaluran_app/app/data/models/petugas_desa_model.dart';
+import 'package:penyaluran_app/app/data/models/donatur_model.dart';
+import 'package:penyaluran_app/app/data/models/desa_model.dart';
 
 class AuthProvider {
   final SupabaseService _supabaseService = SupabaseService.to;
 
-  // Cache untuk menyimpan data profil pengguna
-  UserModel? _cachedUser;
+  // Cache untuk menyimpan data pengguna
+  UserData? _cachedUserData;
 
   // Metode untuk login
-  Future<UserModel?> signIn(String email, String password) async {
+  Future<UserData?> signIn(String email, String password) async {
     try {
-      final response = await _supabaseService.signIn(email, password);
+      // Step 1: Login
+      final response = await _supabaseService.client.auth.signInWithPassword(
+        email: email,
+        password: password,
+      );
 
-      if (response.user != null && response.user?.email != null) {
-        // Ambil profil pengguna dari database
-        final profileData = await _supabaseService.getUserProfile();
-        print('DEBUG: Profile data dari signIn: $profileData');
-
-        if (profileData != null) {
-          // Buat UserModel dengan data yang ada
-          _cachedUser = UserModel.fromJson({
-            ...profileData,
-            'id': response.user!.id,
-            'email': response.user!.email!,
-          });
-          print(
-              'DEBUG: User model dibuat: ${_cachedUser?.name}, desa: ${_cachedUser?.desa?.nama}');
-          return _cachedUser;
-        }
-
-        // Jika profil belum tersedia, gunakan data default
-        _cachedUser = UserModel(
-          id: response.user!.id,
-          email: response.user!.email!,
-          role: 'WARGA', // Default role
-        );
-        print('DEBUG: User model default dibuat: ${_cachedUser?.email}');
-        return _cachedUser;
+      final user = response.user;
+      if (user == null) {
+        print('Login gagal!');
+        return null;
       }
-      return null;
+
+      final userId = user.id;
+
+      // Step 2: Ambil role dari view `users_with_roles` atau tabel roles
+      String roleName;
+      try {
+        final roleResponse = await _supabaseService.client
+            .from('users_with_roles')
+            .select('role_name')
+            .eq('id', userId)
+            .single();
+
+        roleName = roleResponse['role_name'];
+      } catch (e) {
+        print('Error mengambil role dari users_with_roles: $e');
+        print('Mencoba ambil role dari tabel roles...');
+
+        // Fallback ke cara lama jika view users_with_roles tidak tersedia
+        try {
+          // Ambil role_id dari user metadata
+          final roleId = user.userMetadata?['role_id'];
+          if (roleId == null) {
+            print('Tidak ada role_id di user metadata');
+            return null;
+          }
+
+          final roleResponse = await _supabaseService.client
+              .from('roles')
+              .select('role_name')
+              .eq('id', roleId)
+              .single();
+
+          roleName = roleResponse['role_name'];
+        } catch (e) {
+          print('Error mengambil role dari tabel roles: $e');
+          return null;
+        }
+      }
+
+      print('Role: $roleName');
+
+      // Step 3: Ambil profil user berdasarkan role
+      Map<String, dynamic>? profileResponse;
+      dynamic roleData;
+      DesaModel? desa;
+
+      // Buat BaseUserModel
+      final baseUser = BaseUserModel(
+        id: userId,
+        email: user.email ?? '',
+        roleId: user.userMetadata?['role_id'],
+        roleName: roleName,
+        createdAt: DateTime.parse(user.createdAt),
+        updatedAt:
+            user.updatedAt != null ? DateTime.parse(user.updatedAt!) : null,
+      );
+
+      if (roleName == 'warga') {
+        profileResponse = await _supabaseService.client
+            .from('warga')
+            .select('*, desa:desa_id(id, nama, kecamatan, kabupaten, provinsi)')
+            .eq('id', userId)
+            .single();
+
+        if (profileResponse != null) {
+          // Ekstrak data desa jika ada
+          if (profileResponse['desa'] != null) {
+            desa = DesaModel.fromJson(profileResponse['desa']);
+            print('Data Desa: ${desa.nama}');
+          }
+
+          roleData = WargaModel.fromJson(profileResponse);
+          print('Data Warga: ${roleData.namaLengkap}');
+        } else {
+          print('Tidak menemukan data warga untuk ID: $userId');
+          return null;
+        }
+      } else if (roleName == 'petugas_desa') {
+        profileResponse = await _supabaseService.client
+            .from('petugas_desa')
+            .select('*, desa:desa_id(id, nama, kecamatan, kabupaten, provinsi)')
+            .eq('id', userId)
+            .single();
+
+        if (profileResponse != null) {
+          // Ekstrak data desa jika ada
+          if (profileResponse['desa'] != null) {
+            desa = DesaModel.fromJson(profileResponse['desa']);
+            print('Data Desa: ${desa.nama}');
+          }
+
+          roleData = PetugasDesaModel.fromJson(profileResponse);
+          print(
+              'Data Petugas Desa: ${roleData.namaLengkap}, Desa: ${roleData.desa?.nama}');
+        }
+      } else if (roleName == 'donatur') {
+        profileResponse = await _supabaseService.client
+            .from('donatur')
+            .select('*')
+            .eq('id', userId)
+            .single();
+
+        roleData = DonaturModel.fromJson(profileResponse);
+        print('Data Donatur: ${roleData.namaLengkap}');
+      } else {
+        return null;
+      }
+
+      if (roleData == null) {
+        print('Tidak menemukan data profil untuk role: $roleName');
+        return null;
+      }
+
+      // Perbarui baseUser dengan data desa jika ada
+      final updatedBaseUser = BaseUserModel(
+        id: baseUser.id,
+        email: baseUser.email,
+        roleId: baseUser.roleId,
+        roleName: baseUser.roleName,
+        createdAt: baseUser.createdAt,
+        updatedAt: baseUser.updatedAt,
+        desa: desa, // Set desa dari data yang diambil
+      );
+
+      // Simpan cache user data
+      final userData = UserData(
+        baseUser: updatedBaseUser,
+        roleData: roleData,
+      );
+      _cachedUserData = userData;
+
+      return userData;
     } catch (e) {
       print('Error pada signIn: $e');
       rethrow;
@@ -49,57 +167,159 @@ class AuthProvider {
   Future<void> signOut() async {
     try {
       await _supabaseService.signOut();
-      _cachedUser = null; // Hapus cache saat logout
+      _cachedUserData = null; // Hapus cache saat logout
     } catch (e) {
       rethrow;
     }
   }
 
   // Metode untuk mendapatkan user saat ini
-  Future<UserModel?> getCurrentUser() async {
-    // Jika ada cache dan user masih terautentikasi, gunakan cache
-    if (_cachedUser != null && _supabaseService.isAuthenticated) {
-      print(
-          'DEBUG: Menggunakan data user dari cache: ${_cachedUser?.name}, desa: ${_cachedUser?.desa?.nama}');
-      return _cachedUser;
+  Future<UserData?> getCurrentUser({bool skipCache = false}) async {
+    // Jika ada cache dan user masih terautentikasi, gunakan cache kecuali skipCache = true
+    if (!skipCache &&
+        _cachedUserData != null &&
+        _supabaseService.isAuthenticated) {
+      print('DEBUG: Menggunakan data user dari cache');
+      return _cachedUserData;
     }
 
-    final user = _supabaseService.currentUser;
-    if (user != null) {
+    if (_supabaseService.currentUser != null) {
       try {
-        // Ambil profil pengguna dari database
-        final profileData = await _supabaseService.getUserProfile();
-        print('DEBUG: Profile data dari getCurrentUser: $profileData');
+        // Login berhasil, lakukan proses yang sama seperti di signIn
+        // tapi dengan user yang sudah ada
+        final user = _supabaseService.currentUser!;
+        final userId = user.id;
 
-        if (profileData != null) {
-          // Buat UserModel dengan data yang ada
-          _cachedUser = UserModel.fromJson({
-            ...profileData,
-            'id': user.id,
-            'email': user.email!,
-          });
-          print(
-              'DEBUG: User model dibuat: ${_cachedUser?.name}, desa: ${_cachedUser?.desa?.nama}');
-          return _cachedUser;
+        // Step 2: Ambil role dari view `users_with_roles` atau tabel roles
+        String roleName;
+        try {
+          final roleResponse = await _supabaseService.client
+              .from('users_with_roles')
+              .select('role_name')
+              .eq('id', userId)
+              .single();
+
+          roleName = roleResponse['role_name'];
+        } catch (e) {
+          print('Error mengambil role dari users_with_roles: $e');
+          print('Mencoba ambil role dari tabel roles...');
+
+          // Fallback ke cara lama jika view users_with_roles tidak tersedia
+          try {
+            // Ambil role_id dari user metadata
+            final roleId = user.userMetadata?['role_id'];
+            if (roleId == null) {
+              print('Tidak ada role_id di user metadata');
+              return null;
+            }
+
+            final roleResponse = await _supabaseService.client
+                .from('roles')
+                .select('role_name')
+                .eq('id', roleId)
+                .single();
+
+            roleName = roleResponse['role_name'];
+          } catch (e) {
+            print('Error mengambil role dari tabel roles: $e');
+            return null;
+          }
         }
 
-        // Jika profil belum tersedia, gunakan data default
-        _cachedUser = UserModel(
-          id: user.id,
-          email: user.email!,
-          role: 'WARGA', // Default role
+        print('Role: $roleName');
+
+        // Step 3: Ambil profil user berdasarkan role
+        Map<String, dynamic>? profileResponse;
+        dynamic roleData;
+        DesaModel? desa;
+
+        // Buat BaseUserModel
+        final baseUser = BaseUserModel(
+          id: userId,
+          email: user.email ?? '',
+          roleId: user.userMetadata?['role_id'],
+          roleName: roleName ?? '',
+          createdAt: DateTime.parse(user.createdAt),
+          updatedAt:
+              user.updatedAt != null ? DateTime.parse(user.updatedAt!) : null,
         );
-        print('DEBUG: User model default dibuat: ${_cachedUser?.email}');
-        return _cachedUser;
+
+        if ((roleName ?? '').toLowerCase() == 'warga') {
+          profileResponse = await _supabaseService.client
+              .from('warga')
+              .select(
+                  '*, desa:desa_id(id, nama, kecamatan, kabupaten, provinsi)')
+              .eq('id', userId)
+              .single();
+
+          if (profileResponse != null) {
+            // Ekstrak data desa jika ada
+            if (profileResponse['desa'] != null) {
+              desa = DesaModel.fromJson(profileResponse['desa']);
+              print('Data Desa: ${desa.nama}');
+            }
+
+            roleData = WargaModel.fromJson(profileResponse);
+            print('Data Warga: ${roleData.namaLengkap}');
+          } else {
+            print('Tidak menemukan data warga untuk ID: $userId');
+            return null;
+          }
+        } else if (roleName.toLowerCase() == 'petugas_desa') {
+          profileResponse = await _supabaseService.client
+              .from('petugas_desa')
+              .select(
+                  '*, desa:desa_id(id, nama, kecamatan, kabupaten, provinsi)')
+              .eq('id', userId)
+              .single();
+
+          if (profileResponse != null) {
+            // Ekstrak data desa jika ada
+            if (profileResponse['desa'] != null) {
+              desa = DesaModel.fromJson(profileResponse['desa']);
+              print('Data Desa: ${desa.nama}');
+            }
+
+            roleData = PetugasDesaModel.fromJson(profileResponse);
+          }
+        } else if (roleName.toLowerCase() == 'donatur') {
+          profileResponse = await _supabaseService.client
+              .from('donatur')
+              .select('*')
+              .eq('id', userId)
+              .single();
+
+          if (profileResponse != null) {
+            roleData = DonaturModel.fromJson(profileResponse);
+          }
+        }
+
+        if (roleData == null) {
+          print('Tidak menemukan data profil untuk role: $roleName');
+          return null;
+        }
+
+        // Perbarui baseUser dengan data desa jika ada
+        final updatedBaseUser = BaseUserModel(
+          id: baseUser.id,
+          email: baseUser.email,
+          roleId: baseUser.roleId,
+          roleName: baseUser.roleName,
+          createdAt: baseUser.createdAt,
+          updatedAt: baseUser.updatedAt,
+          desa: desa, // Set desa dari data yang diambil
+        );
+
+        // Simpan cache user data
+        final userData = UserData(
+          baseUser: updatedBaseUser,
+          roleData: roleData,
+        );
+        _cachedUserData = userData;
+
+        return userData;
       } catch (e) {
         print('Error pada getCurrentUser: $e');
-        // Jika terjadi error, kembalikan model dengan data minimal
-        _cachedUser = UserModel(
-          id: user.id,
-          email: user.email!,
-          role: 'WARGA', // Default role
-        );
-        return _cachedUser;
       }
     }
     return null;
@@ -115,31 +335,49 @@ class AuthProvider {
     return await _supabaseService.getWargaByUserId();
   }
 
-  // Metode untuk membuat profil warga
-  Future<void> createWargaProfile({
-    required String nik,
-    required String namaLengkap,
-    required String jenisKelamin,
-    String? noHp,
-    String? alamat,
-    String? tempatLahir,
-    DateTime? tanggalLahir,
-    String? agama,
-  }) async {
-    await _supabaseService.createWargaProfile(
-      nik: nik,
-      namaLengkap: namaLengkap,
-      jenisKelamin: jenisKelamin,
-      noHp: noHp,
-      alamat: alamat,
-      tempatLahir: tempatLahir,
-      tanggalLahir: tanggalLahir,
-      agama: agama,
-    );
+  // // Metode untuk membuat profil donatur
+  // Future<void> createDonaturProfile({
+  //   required String namaLengkap,
+  //   String? instansi,
+  //   String? jabatan,
+  //   String? noHp,
+  //   String? alamat,
+  //   String? desaId,
+  // }) async {
+  //   await _supabaseService.createDonaturProfile(
+  //     namaLengkap: namaLengkap,
+  //     instansi: instansi,
+  //     jabatan: jabatan,
+  //     noHp: noHp,
+  //     alamat: alamat,
+  //     desaId: desaId,
+  //   );
 
-    // Invalidasi cache setelah membuat profil baru
-    _cachedUser = null;
-  }
+  //   // Invalidasi cache setelah membuat profil baru
+  //   _cachedUserData = null;
+  // }
+
+  // // Metode untuk membuat profil petugas desa
+  // Future<void> createPetugasDesaProfile({
+  //   required String namaLengkap,
+  //   String? nip,
+  //   String? jabatan,
+  //   String? noHp,
+  //   String? alamat,
+  //   String? desaId,
+  // }) async {
+  //   await _supabaseService.createPetugasDesaProfile(
+  //     namaLengkap: namaLengkap,
+  //     nip: nip,
+  //     jabatan: jabatan,
+  //     noHp: noHp,
+  //     alamat: alamat,
+  //     desaId: desaId,
+  //   );
+
+  //   // Invalidasi cache setelah membuat profil baru
+  //   _cachedUserData = null;
+  // }
 
   // Metode untuk mendapatkan notifikasi pengguna
   Future<List<Map<String, dynamic>>> getUserNotifications(
diff --git a/lib/app/modules/auth/controllers/auth_controller.dart b/lib/app/modules/auth/controllers/auth_controller.dart
index 92ecdb6..7a807b8 100644
--- a/lib/app/modules/auth/controllers/auth_controller.dart
+++ b/lib/app/modules/auth/controllers/auth_controller.dart
@@ -1,17 +1,51 @@
 import 'package:flutter/material.dart';
 import 'package:get/get.dart';
+import 'package:penyaluran_app/app/data/models/donatur_model.dart';
+import 'package:penyaluran_app/app/data/models/petugas_desa_model.dart';
 import 'package:penyaluran_app/app/data/models/user_model.dart';
+import 'package:penyaluran_app/app/data/models/warga_model.dart';
 import 'package:penyaluran_app/app/data/providers/auth_provider.dart';
 import 'package:penyaluran_app/app/routes/app_pages.dart';
-import 'package:penyaluran_app/app/modules/warga/controllers/warga_dashboard_controller.dart';
 
 class AuthController extends GetxController {
   static AuthController get to => Get.find();
 
   final AuthProvider _authProvider = AuthProvider();
 
-  final Rx<UserModel?> _user = Rx<UserModel?>(null);
-  UserModel? get user => _user.value;
+  final Rx<UserData?> _userData = Rx<UserData?>(null);
+  UserData? get userData => _userData.value;
+
+  // Getter untuk BaseUserModel
+  BaseUserModel? get baseUser => _userData.value?.baseUser;
+
+  // Getter untuk role
+  String get role => _userData.value?.baseUser.roleName.toLowerCase() ?? '';
+
+  // Getter dinamis untuk data role-specific
+  dynamic get roleData => _userData.value?.roleData;
+
+  // Getter untuk memeriksa tipe roleData
+  bool get isWarga =>
+      _userData.value?.roleData is WargaModel && role == 'warga';
+  bool get isDonatur =>
+      _userData.value?.roleData is DonaturModel && role == 'donatur';
+  bool get isPetugasDesa =>
+      _userData.value?.roleData is PetugasDesaModel && role == 'petugas_desa';
+
+  // Helper method untuk mendapatkan nama display
+  String get displayName {
+    if (roleData == null) return baseUser?.email ?? 'Pengguna';
+
+    if (isWarga) {
+      return (roleData as WargaModel).displayName;
+    } else if (isDonatur) {
+      return (roleData as DonaturModel).displayName;
+    } else if (isPetugasDesa) {
+      return (roleData as PetugasDesaModel).displayName;
+    }
+
+    return baseUser?.email ?? 'Pengguna';
+  }
 
   final RxBool isLoading = false.obs;
   final RxBool isWargaProfileComplete = false.obs;
@@ -74,21 +108,21 @@ class AuthController extends GetxController {
       print('Memeriksa status autentikasi...');
 
       // Jika user sudah ada di memori dan profil sudah diambil, gunakan data yang ada
-      if (_user.value != null && _hasLoadedProfile.value) {
+      if (_userData.value != null && _hasLoadedProfile.value) {
         print('Menggunakan data user yang sudah ada di memori');
-        _handleAuthenticatedUser(_user.value!);
+        _handleAuthenticatedUser(_userData.value!);
         return;
       }
 
       // Jika belum ada data user, ambil dari provider
-      final currentUser = await _authProvider.getCurrentUser();
+      final currentUserData = await _authProvider.getCurrentUser();
 
-      if (currentUser != null) {
+      if (currentUserData != null) {
         print(
-            'User terautentikasi: ${currentUser.email}, role: ${currentUser.role}');
-        _user.value = currentUser;
+            'User terautentikasi: ${currentUserData.baseUser.email}, role: ${currentUserData.baseUser.roleName}');
+        _userData.value = currentUserData;
         _hasLoadedProfile.value = true;
-        _handleAuthenticatedUser(currentUser);
+        _handleAuthenticatedUser(currentUserData);
       } else {
         print('Tidak ada user yang terautentikasi');
         _handleUnauthenticatedUser();
@@ -104,13 +138,13 @@ class AuthController extends GetxController {
   }
 
   // Metode untuk menangani user yang terautentikasi
-  void _handleAuthenticatedUser(UserModel user) {
+  void _handleAuthenticatedUser(UserData userData) {
     // Hindari navigasi jika sudah berada di halaman yang sesuai
     final currentRoute = Get.currentRoute;
     print('Rute saat ini: $currentRoute');
 
-    // Pastikan role tidak null, gunakan default jika null
-    final role = user.role.isNotEmpty ? user.role : 'WARGA';
+    // Dapatkan role dari BaseUserModel
+    final role = userData.baseUser.roleName.toLowerCase();
     print('Role yang digunakan: $role');
 
     // Untuk semua role, arahkan ke dashboard masing-masing
@@ -146,9 +180,8 @@ class AuthController extends GetxController {
   // Memeriksa status profil warga
   Future<void> checkWargaProfileStatus() async {
     try {
-      if (_user.value?.role == 'WARGA') {
-        final wargaData = await _authProvider.getWargaData();
-        isWargaProfileComplete.value = wargaData != null;
+      if (role == 'warga') {
+        isWargaProfileComplete.value = roleData != null;
       } else {
         isWargaProfileComplete.value = true;
       }
@@ -177,17 +210,14 @@ class AuthController extends GetxController {
     // Bersihkan dependensi form sebelum navigasi
     clearFormDependencies();
 
-    switch (role) {
-      case 'WARGA':
+    switch (role.toLowerCase()) {
+      case 'warga':
         Get.offAllNamed(Routes.wargaDashboard);
         break;
-      case 'PETUGASVERIFIKASI':
-        Get.offAllNamed(Routes.petugasVerifikasiDashboard);
-        break;
-      case 'PETUGASDESA':
+      case 'petugas_desa':
         Get.offAllNamed(Routes.petugasDesaDashboard);
         break;
-      case 'DONATUR':
+      case 'donatur':
         Get.offAllNamed(Routes.donaturDashboard);
         break;
       default:
@@ -229,88 +259,81 @@ class AuthController extends GetxController {
       isLoading.value = true;
 
       print('DEBUG: Memanggil _authProvider.signIn');
-      final user = await _authProvider.signIn(
+      final userData = await _authProvider.signIn(
         email,
         password,
       );
 
-      print('DEBUG: Hasil signIn: ${user != null ? 'Berhasil' : 'Gagal'}');
-      if (user != null) {
-        print('DEBUG: User ditemukan, role: ${user.role}');
-        _user.value = user;
+      print('DEBUG: Hasil signIn: ${userData != null ? 'Berhasil' : 'Gagal'}');
+      if (userData != null) {
+        print('DEBUG: User ditemukan, role: ${userData.baseUser.roleName}');
+        _userData.value = userData;
         _hasLoadedProfile.value = true; // Tandai bahwa profil sudah diambil
         clearControllers();
 
         // Arahkan ke dashboard sesuai peran
-        print('DEBUG: Navigasi berdasarkan peran: ${user.role}');
-        navigateBasedOnRole(user.role);
+        print(
+            'DEBUG: Navigasi berdasarkan peran: ${userData.baseUser.roleName}');
+        navigateBasedOnRole(userData.baseUser.roleName.toLowerCase());
       } else {
         print('DEBUG: User null setelah login berhasil');
+        handleLoginError(Exception('Data pengguna tidak ditemukan'));
       }
     } catch (e) {
-      print('DEBUG: Error detail pada login: $e');
-      print('DEBUG: Stack trace: ${StackTrace.current}');
-      Get.snackbar(
-        'Error',
-        'Login gagal: ${e.toString()}',
-        snackPosition: SnackPosition.TOP,
-        backgroundColor: Colors.red,
-        colorText: Colors.white,
-      );
+      handleLoginError(e);
     } finally {
       print('DEBUG: Mengatur isLoading ke false');
       isLoading.value = false;
     }
   }
 
-  // Metode untuk logout
-  Future<void> logout() async {
-    try {
-      // Ambil semua controller yang mungkin perlu dibersihkan
-      try {
-        final wargaController = Get.find<WargaDashboardController>();
-        wargaController.penerimaPenyaluran.clear();
-        wargaController.pengajuanKelayakan.clear();
-        wargaController.pengaduan.clear();
-      } catch (e) {
-        // Jika controller tidak ditemukan, abaikan
-        print('Controller tidak ditemukan: $e');
-      }
+  // Menangani error saat login
+  void handleLoginError(dynamic error) {
+    print('DEBUG: Error login: $error');
 
-      // Logout dari Supabase
-      await _authProvider.signOut();
+    String errorMessage = 'Terjadi kesalahan saat login. Silakan coba lagi.';
 
-      // Reset semua state
-      _user.value = null;
-      _hasLoadedProfile.value = false;
-      isWargaProfileComplete.value = false;
-
-      // Bersihkan dependensi form sebelum navigasi
-      clearFormDependencies();
-
-      // Navigasi ke halaman login
-      Get.offAllNamed(Routes.login);
-    } catch (e) {
-      Get.snackbar(
-        'Error',
-        'Logout gagal: ${e.toString()}',
-        snackPosition: SnackPosition.TOP,
-        backgroundColor: Colors.red,
-        colorText: Colors.white,
-      );
+    if (error.toString().contains('Invalid login credentials')) {
+      errorMessage = 'Email atau password salah. Silakan coba lagi.';
+    } else if (error.toString().contains('Too many requests')) {
+      errorMessage = 'Terlalu banyak percobaan login. Silakan coba lagi nanti.';
     }
+
+    Get.snackbar(
+      'Error',
+      errorMessage,
+      snackPosition: SnackPosition.TOP,
+      backgroundColor: Colors.red,
+      colorText: Colors.white,
+    );
   }
 
   // Metode untuk membersihkan controller
   void clearControllers() {
+    emailController.clear();
+    passwordController.clear();
+    confirmPasswordController.clear();
+  }
+
+  // Metode untuk logout
+  Future<void> logout() async {
     try {
-      if (emailController.text.isNotEmpty) emailController.clear();
-      if (passwordController.text.isNotEmpty) passwordController.clear();
-      if (confirmPasswordController.text.isNotEmpty) {
-        confirmPasswordController.clear();
-      }
+      isLoading.value = true;
+      await _authProvider.signOut();
+      _userData.value = null;
+      _hasLoadedProfile.value = false;
+      Get.offAllNamed(Routes.login);
     } catch (e) {
-      print('Error clearing controllers: $e');
+      print('Error saat logout: $e');
+      Get.snackbar(
+        'Error',
+        'Terjadi kesalahan saat logout. Silakan coba lagi.',
+        snackPosition: SnackPosition.TOP,
+        backgroundColor: Colors.red,
+        colorText: Colors.white,
+      );
+    } finally {
+      isLoading.value = false;
     }
   }
 
@@ -355,16 +378,42 @@ class AuthController extends GetxController {
     }
   }
 
+  // Metode untuk refresh data user setelah update profil
+  Future<void> refreshUserData() async {
+    try {
+      print('Memperbarui data pengguna...');
+      isLoading.value = true;
+
+      // Hapus cache profil yang sudah tidak valid
+      _hasLoadedProfile.value = false;
+
+      // Ambil data user terbaru dari provider dengan menskip cache
+      final currentUserData =
+          await _authProvider.getCurrentUser(skipCache: true);
+
+      if (currentUserData != null) {
+        print(
+            'Data pengguna berhasil diperbarui: ${currentUserData.baseUser.name}');
+        _userData.value = currentUserData;
+        _hasLoadedProfile.value = true;
+      } else {
+        print('Gagal memperbarui data pengguna');
+      }
+    } catch (e) {
+      print('Error refreshing user data: $e');
+    } finally {
+      isLoading.value = false;
+    }
+  }
+
   // Mendapatkan rute target berdasarkan role
   String _getTargetRouteForRole(String role) {
-    switch (role) {
-      case 'WARGA':
+    switch (role.toLowerCase()) {
+      case 'warga':
         return Routes.wargaDashboard;
-      case 'PETUGASVERIFIKASI':
-        return Routes.petugasVerifikasiDashboard;
-      case 'PETUGASDESA':
+      case 'petugas_desa':
         return Routes.petugasDesaDashboard;
-      case 'DONATUR':
+      case 'donatur':
         return Routes.donaturDashboard;
       default:
         return Routes.home;
